package com.ashokit.advjpa.service;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ashokit.advjpa.dao.BookDao;
import com.ashokit.advjpa.dao.PersonDao;
import com.ashokit.advjpa.model.Book;
import com.ashokit.advjpa.model.Person;

@Service
public class PersonService {
	
	@Autowired
	private PersonDao personDao;
	
	
	@Autowired
	private BookDao bookDao;
	
	
	//saveAll
	
	public Iterable<Book> saveAllBooks(Iterable<Book> booksList)
	{
		return bookDao.saveAll(booksList);
	}
	
	public Iterable<Book> getAllBooks(){
		return bookDao.findAll();
	}
	//SaveAll
	public Iterable<Person> saveAllPersons(Iterable<Person> personsList){
		return personDao.saveAll(personsList);
	}
	
	
	
	//findAllById
	public Iterable<Person> getPersonData(List<Integer> personIds){
		return personDao.findAllById(personIds);
	}
	
	public Person findByLastNameAndFirstName(String lastName,String firstName) {
		return personDao.findByLastNameAndFirstName(lastName, firstName);
	}
	
	public Iterable<Person> findByLastNameOrFirstName(String lastName,String firstName){
		return personDao.findByLastNameOrFirstName(lastName, firstName);
	}
	
	public List<Person> findByLastNameOrderByCreatedDateDesc(String lastName){
		return personDao.findByLastNameOrderByCreatedDateDesc(lastName);
	}
	
	
	public List<Person> findByAgeLessThanEqual(Integer age){
		return personDao.findByAgeLessThanEqual(age);
	}
	
	
	public List<Person> findByFirstNameLike(String firstName){
		return personDao.findByFirstNameLike(firstName);
	}
	
	public List<Person> findByLastNameAndAgeLessThanEqual(String lastName,Integer age){
		return personDao.findByLastNameAndAgeLessThanEqual(lastName,age);
	}
	
	public List<Person> findByCreatedDateBetween(Date startdate,Date endDate){
		return personDao.findByCreatedDateBetween(startdate, endDate);
	}
	


}
